Index: webkitgtk-2.46.6/Source/WebCore/crypto/parameters/RsaOaepParams.idl
===================================================================
--- webkitgtk-2.46.6.orig/Source/WebCore/crypto/parameters/RsaOaepParams.idl
+++ webkitgtk-2.46.6/Source/WebCore/crypto/parameters/RsaOaepParams.idl
@@ -24,6 +24,7 @@
 */
 
 [
+    Conditional=WEB_CRYPTO,
     ImplementedAs=CryptoAlgorithmRsaOaepParams
 ] dictionary RsaOaepParams : CryptoAlgorithmParameters {
     // The optional label/application data to associate with the message
Index: webkitgtk-2.46.6/Source/WebCore/crypto/parameters/RsaPssParams.idl
===================================================================
--- webkitgtk-2.46.6.orig/Source/WebCore/crypto/parameters/RsaPssParams.idl
+++ webkitgtk-2.46.6/Source/WebCore/crypto/parameters/RsaPssParams.idl
@@ -24,6 +24,7 @@
  */
 
 [
+    Conditional=WEB_CRYPTO,
     ImplementedAs=CryptoAlgorithmRsaPssParams
 ] dictionary RsaPssParams : CryptoAlgorithmParameters {
     // The desired length of the random salt
Index: webkitgtk-2.46.6/Source/WebCore/crypto/parameters/X25519Params.idl
===================================================================
--- webkitgtk-2.46.6.orig/Source/WebCore/crypto/parameters/X25519Params.idl
+++ webkitgtk-2.46.6/Source/WebCore/crypto/parameters/X25519Params.idl
@@ -1,4 +1,5 @@
 [
+    Conditional=WEB_CRYPTO,
     ImplementedAs=CryptoAlgorithmX25519Params,
 ] dictionary X25519Params : CryptoAlgorithmParameters {
     required CryptoKey publicKey;
Index: webkitgtk-2.46.6/Source/WebCore/crypto/RsaOtherPrimesInfo.h
===================================================================
--- webkitgtk-2.46.6.orig/Source/WebCore/crypto/RsaOtherPrimesInfo.h
+++ webkitgtk-2.46.6/Source/WebCore/crypto/RsaOtherPrimesInfo.h
@@ -27,6 +27,8 @@
 
 #include <wtf/text/WTFString.h>
 
+#if ENABLE(WEB_CRYPTO)
+
 namespace WebCore {
 
 struct RsaOtherPrimesInfo {
@@ -36,3 +38,5 @@ struct RsaOtherPrimesInfo {
 };
 
 } // namespace WebCore
+
+#endif // ENABLE(WEB_CRYPTO)
Index: webkitgtk-2.46.6/Source/WebCore/crypto/RsaOtherPrimesInfo.idl
===================================================================
--- webkitgtk-2.46.6.orig/Source/WebCore/crypto/RsaOtherPrimesInfo.idl
+++ webkitgtk-2.46.6/Source/WebCore/crypto/RsaOtherPrimesInfo.idl
@@ -24,6 +24,7 @@
  */
 
 [
+    Conditional=WEB_CRYPTO,
     JSGenerateToJSObject,
     JSGenerateToNativeObject
 ] dictionary RsaOtherPrimesInfo {
Index: webkitgtk-2.46.6/Source/WebCore/crypto/SerializedCryptoKeyWrap.h
===================================================================
--- webkitgtk-2.46.6.orig/Source/WebCore/crypto/SerializedCryptoKeyWrap.h
+++ webkitgtk-2.46.6/Source/WebCore/crypto/SerializedCryptoKeyWrap.h
@@ -28,6 +28,8 @@
 #include <wtf/Forward.h>
 #include <wtf/text/WTFString.h>
 
+#if ENABLE(WEB_CRYPTO)
+
 namespace WebCore {
 
 struct WrappedCryptoKey;
@@ -48,3 +50,5 @@ WEBCORE_EXPORT std::optional<WrappedCryp
 WEBCORE_EXPORT std::optional<Vector<uint8_t>> unwrapCryptoKey(const Vector<uint8_t>& masterKey, const struct WrappedCryptoKey& wrappedKey);
 
 } // namespace WebCore
+
+#endif // ENABLE(WEB_CRYPTO)
Index: webkitgtk-2.46.6/Source/WebCore/crypto/SubtleCrypto.cpp
===================================================================
--- webkitgtk-2.46.6.orig/Source/WebCore/crypto/SubtleCrypto.cpp
+++ webkitgtk-2.46.6/Source/WebCore/crypto/SubtleCrypto.cpp
@@ -26,6 +26,8 @@
 #include "config.h"
 #include "SubtleCrypto.h"
 
+#if ENABLE(WEB_CRYPTO)
+
 #include "ContextDestructionObserverInlines.h"
 #include "CryptoAlgorithm.h"
 #include "CryptoAlgorithmRegistry.h"
@@ -66,7 +68,7 @@ SubtleCrypto::SubtleCrypto(ScriptExecuti
 
 SubtleCrypto::~SubtleCrypto() = default;
 
-enum class Operations : uint8_t {
+enum class Operations {
     Encrypt,
     Decrypt,
     Sign,
@@ -1324,4 +1326,6 @@ void SubtleCrypto::unwrapKey(JSC::JSGlob
     unwrapAlgorithm->decrypt(*unwrapParams, unwrappingKey, WTFMove(wrappedKey), WTFMove(callback), WTFMove(exceptionCallback), *scriptExecutionContext(), m_workQueue);
 }
 
-} // namespace WebCore
+}
+
+#endif
Index: webkitgtk-2.46.6/Source/WebCore/crypto/SubtleCrypto.h
===================================================================
--- webkitgtk-2.46.6.orig/Source/WebCore/crypto/SubtleCrypto.h
+++ webkitgtk-2.46.6/Source/WebCore/crypto/SubtleCrypto.h
@@ -25,6 +25,8 @@
 
 #pragma once
 
+#if ENABLE(WEB_CRYPTO)
+
 #include "ContextDestructionObserver.h"
 #include "CryptoKeyFormat.h"
 #include <JavaScriptCore/Strong.h>
@@ -48,7 +50,7 @@ class BufferSource;
 class CryptoKey;
 class DeferredPromise;
 
-enum class CryptoAlgorithmIdentifier : uint8_t;
+enum class CryptoAlgorithmIdentifier;
 enum class CryptoKeyUsage;
 
 class SubtleCrypto : public ContextDestructionObserver, public RefCounted<SubtleCrypto>, public CanMakeWeakPtr<SubtleCrypto> {
@@ -84,4 +86,6 @@ private:
     HashMap<DeferredPromise*, Ref<DeferredPromise>> m_pendingPromises;
 };
 
-} // namespace WebCore
+}
+
+#endif
Index: webkitgtk-2.46.6/Source/WebCore/crypto/SubtleCrypto.idl
===================================================================
--- webkitgtk-2.46.6.orig/Source/WebCore/crypto/SubtleCrypto.idl
+++ webkitgtk-2.46.6/Source/WebCore/crypto/SubtleCrypto.idl
@@ -28,6 +28,7 @@ enum KeyFormat { "raw", "spki", "pkcs8",
 typedef (object or DOMString) AlgorithmIdentifier;
 
 [
+    Conditional=WEB_CRYPTO,
     Exposed=(Window,Worker),
     GenerateIsReachable=ImplScriptExecutionContext,
     SecureContext,
Index: webkitgtk-2.46.6/Source/WebCore/dom/Document.cpp
===================================================================
--- webkitgtk-2.46.6.orig/Source/WebCore/dom/Document.cpp
+++ webkitgtk-2.46.6/Source/WebCore/dom/Document.cpp
@@ -9145,6 +9145,7 @@ void Document::ensurePlugInsInjectedScri
     m_hasInjectedPlugInsScript = true;
 }
 
+#if ENABLE(WEB_CRYPTO)
 std::optional<Vector<uint8_t>> Document::wrapCryptoKey(const Vector<uint8_t>& key)
 {
     RefPtr page = this->page();
@@ -9161,6 +9162,8 @@ std::optional<Vector<uint8_t>>Document::
     return page->cryptoClient().unwrapCryptoKey(wrappedKey);
 }
 
+#endif // ENABLE(WEB_CRYPTO)
+
 Element* Document::activeElement()
 {
     if (Element* element = treeScope().focusedElementInScope())
Index: webkitgtk-2.46.6/Source/WebCore/dom/Document.h
===================================================================
--- webkitgtk-2.46.6.orig/Source/WebCore/dom/Document.h
+++ webkitgtk-2.46.6/Source/WebCore/dom/Document.h
@@ -1621,8 +1621,10 @@ public:
 
     void setVisualUpdatesAllowedByClient(bool);
 
+#if ENABLE(WEB_CRYPTO)
     std::optional<Vector<uint8_t>> wrapCryptoKey(const Vector<uint8_t>&) final;
     std::optional<Vector<uint8_t>> unwrapCryptoKey(const Vector<uint8_t>&) final;
+#endif
 
     void setHasStyleWithViewportUnits() { m_hasStyleWithViewportUnits = true; }
     bool hasStyleWithViewportUnits() const { return m_hasStyleWithViewportUnits; }
Index: webkitgtk-2.46.6/Source/WebCore/dom/EmptyScriptExecutionContext.h
===================================================================
--- webkitgtk-2.46.6.orig/Source/WebCore/dom/EmptyScriptExecutionContext.h
+++ webkitgtk-2.46.6/Source/WebCore/dom/EmptyScriptExecutionContext.h
@@ -77,8 +77,10 @@ public:
     void postTask(Task&&) final { ASSERT_NOT_REACHED(); }
     EventTarget* errorEventTarget() final { return nullptr; };
 
+#if ENABLE(WEB_CRYPTO)
     std::optional<Vector<uint8_t>> wrapCryptoKey(const Vector<uint8_t>&) final { return std::nullopt; }
     std::optional<Vector<uint8_t>> unwrapCryptoKey(const Vector<uint8_t>&) final { return std::nullopt; }
+#endif
 
     JSC::VM& vm() final { return m_vm; }
 
Index: webkitgtk-2.46.6/Source/WebCore/dom/ScriptExecutionContext.h
===================================================================
--- webkitgtk-2.46.6.orig/Source/WebCore/dom/ScriptExecutionContext.h
+++ webkitgtk-2.46.6/Source/WebCore/dom/ScriptExecutionContext.h
@@ -279,11 +279,13 @@ public:
     DatabaseContext* databaseContext() { return m_databaseContext.get(); }
     void setDatabaseContext(DatabaseContext*);
 
+#if ENABLE(WEB_CRYPTO)
     // These two methods are used when CryptoKeys are serialized into IndexedDB. As a side effect, it is also
     // used for things that utilize the same structure clone algorithm, for example, message passing between
     // worker and document.
     virtual std::optional<Vector<uint8_t>> wrapCryptoKey(const Vector<uint8_t>& key) = 0;
     virtual std::optional<Vector<uint8_t>> unwrapCryptoKey(const Vector<uint8_t>& wrappedKey) = 0;
+#endif
 
     int timerNestingLevel() const { return m_timerNestingLevel; }
     void setTimerNestingLevel(int timerNestingLevel) { m_timerNestingLevel = timerNestingLevel; }
Index: webkitgtk-2.46.6/Source/WebCore/page/Crypto.cpp
===================================================================
--- webkitgtk-2.46.6.orig/Source/WebCore/page/Crypto.cpp
+++ webkitgtk-2.46.6/Source/WebCore/page/Crypto.cpp
@@ -46,7 +46,9 @@ namespace WebCore {
 
 Crypto::Crypto(ScriptExecutionContext* context)
     : ContextDestructionObserver(context)
+#if ENABLE(WEB_CRYPTO)
     , m_subtle(SubtleCrypto::create(context))
+#endif
 {
 }
 
@@ -72,9 +74,13 @@ String Crypto::randomUUID() const
     return createVersion4UUIDString();
 }
 
+#if ENABLE(WEB_CRYPTO)
+
 SubtleCrypto& Crypto::subtle()
 {
     return m_subtle;
 }
 
-} // namespace WebCore
+#endif
+
+}
Index: webkitgtk-2.46.6/Source/WebCore/page/Crypto.h
===================================================================
--- webkitgtk-2.46.6.orig/Source/WebCore/page/Crypto.h
+++ webkitgtk-2.46.6/Source/WebCore/page/Crypto.h
@@ -48,12 +48,16 @@ public:
     ExceptionOr<void> getRandomValues(JSC::ArrayBufferView&);
     String randomUUID() const;
 
+#if ENABLE(WEB_CRYPTO)
     SubtleCrypto& subtle();
+#endif
 
 private:
     Crypto(ScriptExecutionContext*);
 
+#if ENABLE(WEB_CRYPTO)
     Ref<SubtleCrypto> m_subtle;
+#endif
 };
 
 }
Index: webkitgtk-2.46.6/Source/WebCore/page/Crypto.idl
===================================================================
--- webkitgtk-2.46.6.orig/Source/WebCore/page/Crypto.idl
+++ webkitgtk-2.46.6/Source/WebCore/page/Crypto.idl
@@ -31,7 +31,7 @@
     Exposed=(Window,Worker),
     GenerateIsReachable=ImplScriptExecutionContext
 ] interface Crypto {
-    [SecureContext] readonly attribute SubtleCrypto subtle;
+    [Conditional=WEB_CRYPTO, SecureContext] readonly attribute SubtleCrypto subtle;
     ArrayBufferView getRandomValues([ReturnValue] ArrayBufferView array);
     [SecureContext] DOMString randomUUID();
 };
Index: webkitgtk-2.46.6/Source/WebCore/PAL/pal/PlatformGTK.cmake
===================================================================
--- webkitgtk-2.46.6.orig/Source/WebCore/PAL/pal/PlatformGTK.cmake
+++ webkitgtk-2.46.6/Source/WebCore/PAL/pal/PlatformGTK.cmake
@@ -3,16 +3,12 @@ list(APPEND PAL_PUBLIC_HEADERS
     crypto/gcrypt/Initialization.h
     crypto/gcrypt/Utilities.h
 
-    crypto/tasn1/Utilities.h
-
     system/glib/SleepDisablerGLib.h
 )
 
 list(APPEND PAL_SOURCES
     crypto/gcrypt/CryptoDigestGCrypt.cpp
 
-    crypto/tasn1/Utilities.cpp
-
     system/ClockGeneric.cpp
 
     system/glib/SleepDisablerGLib.cpp
@@ -24,6 +20,16 @@ list(APPEND PAL_SOURCES
     unix/LoggingUnix.cpp
 )
 
+if (ENABLE_WEB_CRYPTO)
+    list(APPEND PAL_PUBLIC_HEADERS
+        crypto/tasn1/Utilities.h
+    )
+
+    list(APPEND PAL_SOURCES
+        crypto/tasn1/Utilities.cpp
+    )
+endif ()
+
 list(APPEND PAL_LIBRARIES
     GTK::GTK
 )
Index: webkitgtk-2.46.6/Source/WebCore/platform/GCrypt.cmake
===================================================================
--- webkitgtk-2.46.6.orig/Source/WebCore/platform/GCrypt.cmake
+++ webkitgtk-2.46.6/Source/WebCore/platform/GCrypt.cmake
@@ -1,6 +1,8 @@
-list(APPEND WebCore_UNIFIED_SOURCE_LIST_FILES
-    "platform/SourcesGCrypt.txt"
-)
+if (ENABLE_WEB_CRYPTO)
+    list(APPEND WebCore_UNIFIED_SOURCE_LIST_FILES
+        "platform/SourcesGCrypt.txt"
+    )
+endif ()
 
 list(APPEND WebCore_LIBRARIES
     LibGcrypt::LibGcrypt
Index: webkitgtk-2.46.6/Source/WebCore/platform/LocalizedStrings.cpp
===================================================================
--- webkitgtk-2.46.6.orig/Source/WebCore/platform/LocalizedStrings.cpp
+++ webkitgtk-2.46.6/Source/WebCore/platform/LocalizedStrings.cpp
@@ -1469,11 +1469,17 @@ String useBlockedPlugInContextMenuTitle(
     return WEB_UI_STRING("Show in blocked plug-in", "Title of the context menu item to show when PDFPlugin was used instead of a blocked plugin");
 }
 
-#if PLATFORM(COCOA)
+#if ENABLE(WEB_CRYPTO) && PLATFORM(COCOA)
 
 String webCryptoMasterKeyKeychainLabel(const String& localizedApplicationName)
 {
+#if PLATFORM(COCOA)
     return WEB_UI_FORMAT_CFSTRING("%@ WebCrypto Master Key", "Name of application's single WebCrypto master key in Keychain", localizedApplicationName.createCFString().get());
+#elif USE(GLIB)
+    return WEB_UI_FORMAT_STRING("%s WebCrypto Master Key", "Name of application's single WebCrypto master key in Keychain", localizedApplicationName.utf8().data());
+#else
+    return makeStringByReplacingAll(WEB_UI_STRING("<application> WebCrypto Master Key", "Name of application's single WebCrypto master key in Keychain"), "<application>"_s, localizedApplicationName);
+#endif
 }
 
 String webCryptoMasterKeyKeychainComment()
Index: webkitgtk-2.46.6/Source/WebCore/platform/LocalizedStrings.h
===================================================================
--- webkitgtk-2.46.6.orig/Source/WebCore/platform/LocalizedStrings.h
+++ webkitgtk-2.46.6/Source/WebCore/platform/LocalizedStrings.h
@@ -376,7 +376,7 @@ namespace WebCore {
 
     WEBCORE_EXPORT String useBlockedPlugInContextMenuTitle();
 
-#if PLATFORM(COCOA)
+#if ENABLE(WEB_CRYPTO) && PLATFORM(COCOA)
     String webCryptoMasterKeyKeychainLabel(const String& localizedApplicationName);
     String webCryptoMasterKeyKeychainComment();
 #endif
Index: webkitgtk-2.46.6/Source/WebCore/platform/OpenSSL.cmake
===================================================================
--- webkitgtk-2.46.6.orig/Source/WebCore/platform/OpenSSL.cmake
+++ webkitgtk-2.46.6/Source/WebCore/platform/OpenSSL.cmake
@@ -1,3 +1,4 @@
+if (ENABLE_WEB_CRYPTO)
 list(APPEND WebCore_SOURCES
     crypto/openssl/CryptoAlgorithmAESCBCOpenSSL.cpp
     crypto/openssl/CryptoAlgorithmAESCFBOpenSSL.cpp
@@ -19,3 +20,4 @@ list(APPEND WebCore_SOURCES
     crypto/openssl/OpenSSLUtilities.cpp
     crypto/openssl/SerializedCryptoKeyWrapOpenSSL.cpp
 )
+endif
Index: webkitgtk-2.46.6/Source/WebCore/workers/WorkerGlobalScope.cpp
===================================================================
--- webkitgtk-2.46.6.orig/Source/WebCore/workers/WorkerGlobalScope.cpp
+++ webkitgtk-2.46.6/Source/WebCore/workers/WorkerGlobalScope.cpp
@@ -488,6 +488,7 @@ void WorkerGlobalScope::addMessage(Messa
     InspectorInstrumentation::addMessageToConsole(*this, WTFMove(message));
 }
 
+#if ENABLE(WEB_CRYPTO)
 std::optional<Vector<uint8_t>> WorkerGlobalScope::wrapCryptoKey(const Vector<uint8_t>& key)
 {
     Ref protectedThis { *this };
@@ -522,6 +523,8 @@ std::optional<Vector<uint8_t>> WorkerGlo
     return key;
 }
 
+#endif // ENABLE(WEB_CRYPTO)
+
 Crypto& WorkerGlobalScope::crypto()
 {
     if (!m_crypto)
Index: webkitgtk-2.46.6/Source/WebCore/workers/WorkerGlobalScope.h
===================================================================
--- webkitgtk-2.46.6.orig/Source/WebCore/workers/WorkerGlobalScope.h
+++ webkitgtk-2.46.6/Source/WebCore/workers/WorkerGlobalScope.h
@@ -206,8 +206,10 @@ private:
 
     bool shouldBypassMainWorldContentSecurityPolicy() const final { return m_shouldBypassMainWorldContentSecurityPolicy; }
 
+#if ENABLE(WEB_CRYPTO)
     std::optional<Vector<uint8_t>> wrapCryptoKey(const Vector<uint8_t>& key) final;
     std::optional<Vector<uint8_t>> unwrapCryptoKey(const Vector<uint8_t>& wrappedKey) final;
+#endif
 
     // ReportingClient.
     void notifyReportObservers(Ref<Report>&&) final;
Index: webkitgtk-2.46.6/Source/WebCore/worklets/WorkletGlobalScope.h
===================================================================
--- webkitgtk-2.46.6.orig/Source/WebCore/worklets/WorkletGlobalScope.h
+++ webkitgtk-2.46.6/Source/WebCore/worklets/WorkletGlobalScope.h
@@ -104,8 +104,10 @@ private:
 
     EventTarget* errorEventTarget() final { return this; }
 
+#if ENABLE(WEB_CRYPTO)
     std::optional<Vector<uint8_t>> wrapCryptoKey(const Vector<uint8_t>&) final { RELEASE_ASSERT_NOT_REACHED(); return std::nullopt; }
     std::optional<Vector<uint8_t>> unwrapCryptoKey(const Vector<uint8_t>&) final { RELEASE_ASSERT_NOT_REACHED(); return std::nullopt; }
+#endif
     URL completeURL(const String&, ForceUTF8 = ForceUTF8::No) const final;
     String userAgent(const URL&) const final;
     const Settings::Values& settingsValues() const final { return m_settingsValues; }
Index: webkitgtk-2.46.6/Source/WebKit/UIProcess/API/C/WKPage.cpp
===================================================================
--- webkitgtk-2.46.6.orig/Source/WebKit/UIProcess/API/C/WKPage.cpp
+++ webkitgtk-2.46.6/Source/WebKit/UIProcess/API/C/WKPage.cpp
@@ -2345,6 +2345,7 @@ void WKPageSetPageNavigationClient(WKPag
             return false;
         }
 
+#if ENABLE(WEB_CRYPTO)
         void legacyWebCryptoMasterKey(WebKit::WebPageProxy& page, CompletionHandler<void(std::optional<Vector<uint8_t>>&&)>&& completionHandler) override
         {
             if (m_client.copyWebCryptoMasterKey) {
@@ -2353,6 +2354,7 @@ void WKPageSetPageNavigationClient(WKPag
             }
             return completionHandler(defaultWebCryptoMasterKey());
         }
+#endif
 
         void navigationActionDidBecomeDownload(WebKit::WebPageProxy& page, API::NavigationAction& action, WebKit::DownloadProxy& download) override
         {
Index: webkitgtk-2.46.6/Source/WebKit/UIProcess/WebPageProxy.cpp
===================================================================
--- webkitgtk-2.46.6.orig/Source/WebKit/UIProcess/WebPageProxy.cpp
+++ webkitgtk-2.46.6/Source/WebKit/UIProcess/WebPageProxy.cpp
@@ -11845,6 +11845,7 @@ void WebPageProxy::getWebCryptoMasterKey
 
 }
 
+#if ENABLE(WEB_CRYPTO)
 void WebPageProxy::wrapCryptoKey(Vector<uint8_t>&& key, CompletionHandler<void(std::optional<Vector<uint8_t>>&&)>&& completionHandler)
 {
     getWebCryptoMasterKey([key = WTFMove(key), completionHandler = WTFMove(completionHandler)](std::optional<Vector<uint8_t>> && masterKey) mutable {
@@ -11874,6 +11875,7 @@ void WebPageProxy::unwrapCryptoKey(Wrapp
     });
 
 }
+#endif
 
 void WebPageProxy::changeFontAttributes(WebCore::FontAttributeChanges&& changes)
 {
Index: webkitgtk-2.46.6/Source/WebKit/UIProcess/WebPageProxy.h
===================================================================
--- webkitgtk-2.46.6.orig/Source/WebKit/UIProcess/WebPageProxy.h
+++ webkitgtk-2.46.6/Source/WebKit/UIProcess/WebPageProxy.h
@@ -1776,8 +1776,10 @@ public:
     RefPtr<ViewSnapshot> takeViewSnapshot(std::optional<WebCore::IntRect>&&, ForceSoftwareCapturingViewportSnapshot);
 #endif
 
+#if ENABLE(WEB_CRYPTO)
     void wrapCryptoKey(Vector<uint8_t>&&, CompletionHandler<void(std::optional<Vector<uint8_t>>&&)>&&);
     void unwrapCryptoKey(WebCore::WrappedCryptoKey&&, CompletionHandler<void(std::optional<Vector<uint8_t>>&&)>&&);
+#endif
 
     void takeSnapshot(WebCore::IntRect, WebCore::IntSize bitmapSize, SnapshotOptions, CompletionHandler<void(std::optional<WebCore::ShareableBitmapHandle>&&)>&&);
 
Index: webkitgtk-2.46.6/Source/WebKit/UIProcess/WebPageProxy.messages.in
===================================================================
--- webkitgtk-2.46.6.orig/Source/WebKit/UIProcess/WebPageProxy.messages.in
+++ webkitgtk-2.46.6/Source/WebKit/UIProcess/WebPageProxy.messages.in
@@ -410,8 +410,10 @@ messages -> WebPageProxy {
 
     DidUpdateActivityState() CanDispatchOutOfOrder
 
+#if ENABLE(WEB_CRYPTO)
     WrapCryptoKey(Vector<uint8_t> key) -> (std::optional<Vector<uint8_t>> wrappedKey) Synchronous
     UnwrapCryptoKey(struct WebCore::WrappedCryptoKey wrappedKey) -> (std::optional<Vector<uint8_t>> key) Synchronous
+#endif
 
 
 #if ENABLE(TELEPHONE_NUMBER_DETECTION)
Index: webkitgtk-2.46.6/Source/WebKit/UIProcess/WebProcessProxy.cpp
===================================================================
--- webkitgtk-2.46.6.orig/Source/WebKit/UIProcess/WebProcessProxy.cpp
+++ webkitgtk-2.46.6/Source/WebKit/UIProcess/WebProcessProxy.cpp
@@ -2663,6 +2663,7 @@ void WebProcessProxy::getNotifications(c
     WebNotificationManagerProxy::sharedServiceWorkerManager().getNotifications(registrationURL, tag, sessionID(), WTFMove(callback));
 }
 
+#if ENABLE(WEB_CRYPTO)
 void WebProcessProxy::getWebCryptoMasterKey(CompletionHandler<void(std::optional<Vector<uint8_t>>&&)>&& completionHandler)
 {
     m_websiteDataStore->client().webCryptoMasterKey([completionHandler = WTFMove(completionHandler)](std::optional<Vector<uint8_t>>&& key) mutable {
@@ -2671,7 +2672,9 @@ void WebProcessProxy::getWebCryptoMaster
         return completionHandler(WebCore::defaultWebCryptoMasterKey());
     });
 }
+#endif
 
+#if ENABLE(WEB_CRYPTO)
 void WebProcessProxy::wrapCryptoKey(Vector<uint8_t>&& key, CompletionHandler<void(std::optional<Vector<uint8_t>>&&)>&& completionHandler)
 {
     getWebCryptoMasterKey([key = WTFMove(key), completionHandler = WTFMove(completionHandler)](std::optional<Vector<uint8_t>> && masterKey) mutable {
@@ -2699,8 +2702,9 @@ void WebProcessProxy::unwrapCryptoKey(Wr
             return completionHandler(WTFMove(key));
         completionHandler(std::nullopt);
     });
-
 }
+#endif
+
 void WebProcessProxy::setAppBadge(std::optional<WebPageProxyIdentifier> pageIdentifier, const SecurityOriginData& origin, std::optional<uint64_t> badge)
 {
     if (!pageIdentifier) {
Index: webkitgtk-2.46.6/Source/WebKit/UIProcess/WebProcessProxy.h
===================================================================
--- webkitgtk-2.46.6.orig/Source/WebKit/UIProcess/WebProcessProxy.h
+++ webkitgtk-2.46.6/Source/WebKit/UIProcess/WebProcessProxy.h
@@ -550,7 +550,9 @@ private:
 
     void validateFreezerStatus();
 
+#if ENABLE(WEB_CRYPTO)
     void getWebCryptoMasterKey(CompletionHandler<void(std::optional<Vector<uint8_t>>&&)>&&);
+#endif
     using WebProcessProxyMap = HashMap<WebCore::ProcessIdentifier, CheckedRef<WebProcessProxy>>;
     static WebProcessProxyMap& allProcessMap();
     static Vector<Ref<WebProcessProxy>> allProcesses();
Index: webkitgtk-2.46.6/Source/WebKit/UIProcess/WebProcessProxy.messages.in
===================================================================
--- webkitgtk-2.46.6.orig/Source/WebKit/UIProcess/WebProcessProxy.messages.in
+++ webkitgtk-2.46.6/Source/WebKit/UIProcess/WebProcessProxy.messages.in
@@ -89,6 +89,8 @@ messages -> WebProcessProxy LegacyReceiv
     [EnabledBy=AppBadgeEnabled] SetAppBadge(std::optional<WebKit::WebPageProxyIdentifier> pageIdentifier, WebCore::SecurityOriginData origin, std::optional<uint64_t> badge)
     [EnabledBy=AppBadgeEnabled] SetClientBadge(WebKit::WebPageProxyIdentifier pageIdentifier, WebCore::SecurityOriginData origin, std::optional<uint64_t> badge)
 
+#if ENABLE(WEB_CRYPTO)
     WrapCryptoKey(Vector<uint8_t> key) -> (std::optional<Vector<uint8_t>> wrappedKey) Synchronous
     UnwrapCryptoKey(struct WebCore::WrappedCryptoKey wrappedKey) -> (std::optional<Vector<uint8_t>> key) Synchronous
+#endif
 }
Index: webkitgtk-2.46.6/Source/WebKit/WebProcess/WebCoreSupport/WebCryptoClient.cpp
===================================================================
--- webkitgtk-2.46.6.orig/Source/WebKit/WebProcess/WebCoreSupport/WebCryptoClient.cpp
+++ webkitgtk-2.46.6/Source/WebKit/WebProcess/WebCoreSupport/WebCryptoClient.cpp
@@ -38,6 +38,7 @@ namespace WebKit {
 
 WTF_MAKE_TZONE_ALLOCATED_IMPL(WebCryptoClient);
 
+#if ENABLE(WEB_CRYPTO)
 std::optional<Vector<uint8_t>> WebCryptoClient::wrapCryptoKey(const Vector<uint8_t>& key) const
 {
     if (m_pageIdentifier) {
@@ -67,6 +68,7 @@ std::optional<Vector<uint8_t>> WebCrypto
     auto [unwrappedKey] = sendResult.takeReplyOr(std::nullopt);
     return unwrappedKey;
 }
+#endif
 
 WebCryptoClient::WebCryptoClient(WebCore::PageIdentifier pageIdentifier)
     : m_pageIdentifier(pageIdentifier)
Index: webkitgtk-2.46.6/Source/WebKit/WebProcess/WebCoreSupport/WebCryptoClient.h
===================================================================
--- webkitgtk-2.46.6.orig/Source/WebKit/WebProcess/WebCoreSupport/WebCryptoClient.h
+++ webkitgtk-2.46.6/Source/WebKit/WebProcess/WebCoreSupport/WebCryptoClient.h
@@ -40,8 +40,10 @@ public:
     WebCryptoClient(WebCore::PageIdentifier);
     WebCryptoClient() = default;
     ~WebCryptoClient() = default;
+#if ENABLE(WEB_CRYPTO)
     std::optional<Vector<uint8_t>> wrapCryptoKey(const Vector<uint8_t>&) const override;
     std::optional<Vector<uint8_t>> unwrapCryptoKey(const Vector<uint8_t>&) const override;
+#endif
 private:
     std::optional<WebCore::PageIdentifier> m_pageIdentifier;
 };
Index: webkitgtk-2.46.6/Source/WTF/wtf/PlatformEnableCocoa.h
===================================================================
--- webkitgtk-2.46.6.orig/Source/WTF/wtf/PlatformEnableCocoa.h
+++ webkitgtk-2.46.6/Source/WTF/wtf/PlatformEnableCocoa.h
@@ -931,6 +931,10 @@
 #define ENABLE_WEB_CODECS 1
 #endif
 
+#if !defined(ENABLE_WEB_CRYPTO)
+#define ENABLE_WEB_CRYPTO 1
+#endif
+
 #if !defined(ENABLE_WEB_PLAYBACK_CONTROLS_MANAGER) && PLATFORM(MAC)
 #define ENABLE_WEB_PLAYBACK_CONTROLS_MANAGER 1
 #endif
